#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

#define ll long long

using namespace std;

const int L = 200;
char tabulka[L][L];
int vstup[L][L];
bool byl[L][L];
vector< int > syn[10000];

int main()
{
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            cin >> tabulka[i][j];
            vstup[i][j] = -1;
        }
    }
    int p = 0;
    int dx[] = {-1,0,1,0};
    int dy[] = {0,-1,0,1};
    queue<pair<int, int> > fr;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            if(!byl[i][j]){
                p++;
                if(i > 0) syn[vstup[i-1][j]].push_back(p);
                fr.push({i,j});
                while(!fr.empty()){
                    int x = fr.front().first;
                    int y = fr.front().second;
                    fr.pop();
                    if(byl[x][y]) continue;
                    byl[x][y] = 1;
                    vstup[x][y] = p;
                    for(int h = 0; h < 4; h++){
                        int x1 = x + dx[h];
                        int y1 = y + dy[h];
                        if(!byl[x1][y1] && tabulka[x1][y1] == tabulka[x][y]) fr.push({x1,y1});
                    }

                }
            }
        }
    }
    for(int i = 1; i < 10; i++){
        cout << i << endl;
        for(int j = 0; j < syn[i].size(); j++) cout << syn[i][j] << " ";
        cout << endl;
    }
    return 0;
}
